@Echo Off
setlocal enabledelayedexpansion

Title Qompiler v1.0

:Start
If Not Exist *.MAP GoTo NeedMaps
If Not Exist tools\qbsp.exe GoTo NoTools
If Not Exist tools\vis.exe GoTo NoTools
If Not Exist tools\light.exe GoTo NoTools
If Not Exist Docs\Nul MD Docs
If Not Exist Qompiled\Nul MD Qompiled
If Not Exist Maps\Nul MD Maps
If Not Exist Logs\Nul MD Logs
If Not Exist Configs\Nul MD Configs
If Exist "visdescription.bat" Move "visdescription.bat" "Docs"
If Exist "lightdescription.bat" Move "lightdescription.bat" "Docs"
If Exist "qbspdescription.bat" Move "qbspdescription.bat" "Docs"
If Exist "muk.bat" move "muk.bat" "Configs"
If "%1"=="DoIt" GoTo Qompile
If Not "%1"=="" GoTo NeedMaps
Echo Lets Qompile some maps.
Echo.
Echo 1. [N]ew Configuration
Echo 2. [L]oad Configuration
Echo.
Choice /N /C:NL
If ERRORLEVEL 2 GoTo Load
If ERRORLEVEL 1 GoTo NewConfig
Echo.

:NoConfigs
Echo.
Echo No configurations found...
Echo.

:NewConfig
Echo.
Echo What would you like to name this configuration?
Echo.
Set /p _config=
If Exist Configs\%_config%.bat GoTo Overwrite 
) else (
GoTo Settings

:Overwrite
Echo.
Echo	The config %_config% already exists.
Echo.
Echo 1. [O]verwrite old config
Echo 2. [R]ename current
Echo.
Choice /N /C:OR
If ERRORLEVEL 2 GoTo NewConfig
If ERRORLEVEL 1 GoTo Settings


:Load
Echo.
Echo	Here are the currently available configurations:
Echo.
>nul 2>nul dir /a-d /s "Configs\*.bat" && (dir /a-d /b Configs\*.bat) || (GoTo NoConfigs)
Echo.
Echo What configuration would you like to load?
Echo.
Set /p _config=
Echo.
If Exist Configs/%_config%.bat GoTo Run
) else ( 
Echo Configuration "%_config%" does not exist..
GoTo Load

:Settings
Call docs\qbspdescription.bat
Set /p _qbsp=Input any desired qbsp settings, then press "Enter" to continue...
Echo.
Call docs\visdescription.bat
Set /p _vis=Input any desired vis settings, then press "Enter" to continue...
Echo.
Call docs\lightdescription.bat
Set /p _light=Input any desired light settings. Pres "Enter" to continue...
Echo ::Generated by Qompilerv1.0>configs\%_config%.bat
Echo set _qbsp=%_qbsp%>>configs\%_config%.bat
Echo set _vis=%_vis%>>configs\%_config%.bat
Echo set _light=%_light%>>configs\%_config%.bat
Echo.

:Run
Echo Using configuration "%_config%"...
For %%i in (*.MAP) do call Qompiler DoIt %%i
Echo Finished.
GoTo End

:Qompile
Echo Qompiling map %2...
tools\qbsp.exe %_qbsp% %2 >nul
tools\vis.exe %_vis% %2 >nul
tools\light.exe %_light% %2 >nul
Echo %2>>Logs\Qompiled.txt
Move %2 Qompiled>Nul
Echo.
Echo -[Finished Qompiling %2...]-
Echo.
@for /F "delims=" %%a in ('findstr /I "warning" *.log') do @echo %%a
@for /F "delims=" %%a in ('findstr /I "error" *.log') do @echo %%a
If Exist "*.prt" Del "*.prt">Nul
If Exist "*.bsp" Move "*.bsp" Maps>Nul
If Exist "*.lit" Move "*.lit" Maps>Nul
If Exist "*.log" Move "*.log" Logs>Nul
Echo.
Goto QompileEnd



:NeedMaps
Echo Qompiler and your maps must be in the same folder.  
Echo Be sure your compiling tools are in the Tools directory, as well.
Goto Restart

:NoTools
Echo Need qbsp.exe/vis.exe/light.exe in the Tools directory.
Goto Restart

:Restart
Echo.
Echo Do you wish to restart?
Choice /C:YN
If ERRORLEVEL 2 GoTo End
If ERRORLEVEL 1 GoTo Start

:End
Echo.
Pause

:QompileEnd